#!/bin/bash
#like dumpframe, but takes a frame number, reads a PPM file from stdin,
#and *inserts* that frame into the video stream at the relevant point.
#As with dumpframe/viewframe, frames are numbered from 0, although it's
#recommended that maybe you avoid using that frame in case I got the
#header size wrong :P

header=512 #well well, and that way round, the pixels are in plain old RGB :)
framesize=9216 #Had this wrong for some time, thinking res was 48x96 :P
#seekno=`ev \($1*$framesize\)+$header`
seekno=`expr \( $1 \* $framesize \) \+ $header`
#"expr" took a lot more work than "ev" for it to parse, but most people
#wouldn't have "ev".


#there's no "ppmtoraw" command, so I had to pack that functionality into
#the "repackrgb12" script, which parses the headers in a pretty cranky way.
#NB: Noticed after a while that if just rotating the frames, they end up
#back-to-front, so must be flipped over with the -lr option to pnmflip.
pnmflip -lr -r90 |./repackrgb12.c \
 |dd seek=$seekno count=$framesize bs=1 of=source.pfl conv=notrunc

#can dd be used with "notrunc" to replace data in the middle of a file?
#Apparently, yes!!

